package farmako
  connector fc
    Real conc;
    flow Real cq;
    annotation(Diagram(coordinateSystem(extent = {{-100,-100},{100,100}}, preserveAspectRatio = true, initialScale = 0.1, grid = {2,2})), Icon(coordinateSystem(extent = {{-100,-100},{100,100}}, preserveAspectRatio = true, initialScale = 0.1, grid = {2,2}), graphics = {Polygon(origin = {2.06,-9.61}, fillColor = {170,0,0}, fillPattern = FillPattern.Solid, points = {{-14.4165,88.3295},{-35.0114,25.6293},{-99.5423,40.7323},{-38.6728,-23.341},{-55.6064,-88.3295},{7.09382,-30.2059},{74.8284,-86.4989},{45.9954,-16.476},{99.5423,27.9176},{25.4005,28.833},{-14.4165,88.3295}})}));
  end fc;
  model concKomp
    farmako.fc fc1 annotation(Placement(visible = true, transformation(origin = {-7.32265,16.0183}, extent = {{-10,-10},{10,10}}, rotation = 0), iconTransformation(origin = {-7.32265,16.0183}, extent = {{-10,-10},{10,10}}, rotation = 0)));
    Real totalMass(start = startConc / distVol);
    parameter Real distVol;
    parameter Real startConc;
  equation
    der(totalMass) = fc1.cq;
    fc1.conc = totalMass / distVol;
    annotation(Icon(coordinateSystem(extent = {{-100,-100},{100,100}}, preserveAspectRatio = true, initialScale = 0.1, grid = {2,2})), Diagram(coordinateSystem(extent = {{-100,-100},{100,100}}, preserveAspectRatio = true, initialScale = 0.1, grid = {2,2}), graphics = {Rectangle(origin = {-2.18,-0.93}, fillColor = {15,17,170}, fillPattern = FillPattern.Solid, extent = {{-86.29,76.32},{86.29,-76.32}})}));
  end concKomp;
  model kidney
    farmako.fc fc1 annotation(Placement(visible = true, transformation(origin = {19.222,-1.373}, extent = {{-10,-10},{10,10}}, rotation = 0), iconTransformation(origin = {-5.03432,-0.457666}, extent = {{-10,-10},{10,10}}, rotation = 0)));
    parameter Real CL;
  equation
    fc1.cq = fc1.conc * CL;
    // test
    // test2
    annotation(Diagram(coordinateSystem(extent = {{-100,-100},{100,100}}, preserveAspectRatio = true, initialScale = 0.1, grid = {2,2})), Icon(coordinateSystem(extent = {{-100,-100},{100,100}}, preserveAspectRatio = true, initialScale = 0.1, grid = {2,2}), graphics = {Polygon(origin = {-2.28833,-9.61098}, fillColor = {170,0,0}, fillPattern = FillPattern.Solid, points = {{-68.1922,86.0412},{48.9703,86.9565},{94.7368,-5.49199},{28.833,-86.9565},{-53.0892,-83.7529},{-94.7368,3.20366},{-68.1922,86.0412}})}));
  end kidney;
  package components
    connector kon1
      Real f;
      annotation(Icon(coordinateSystem(extent = {{-100,-100},{100,100}}, preserveAspectRatio = true, initialScale = 0.1, grid = {2,2})), Diagram(coordinateSystem(extent = {{-100,-100},{100,100}}, preserveAspectRatio = true, initialScale = 0.1, grid = {2,2})));
    end kon1;
    annotation(Icon(coordinateSystem(extent = {{-100,-100},{100,100}}, preserveAspectRatio = true, initialScale = 0.1, grid = {2,2})), Diagram(coordinateSystem(extent = {{-100,-100},{100,100}}, preserveAspectRatio = true, initialScale = 0.1, grid = {2,2})));
  end components;
  model system
    farmako.concKomp conckomp1(distVol = 10, startConc = 1) annotation(Placement(visible = true, transformation(origin = {-29.5652,21.3043}, extent = {{-10,-10},{10,10}}, rotation = 0)));
    farmako.kidney kidney1(CL = 2) annotation(Placement(visible = true, transformation(origin = {47.8261,8.26087}, extent = {{-10,-10},{10,10}}, rotation = 0)));
  equation
    connect(conckomp1.fc1,kidney1.fc1) annotation(Line(points = {{-30.2975,22.9062},{46.1059,22.9062},{46.1059,8.09969},{46.1059,8.09969}}));
    annotation(Icon(coordinateSystem(extent = {{-100,-100},{100,100}}, preserveAspectRatio = true, initialScale = 0.1, grid = {2,2})), Diagram(coordinateSystem(extent = {{-100,-100},{100,100}}, preserveAspectRatio = true, initialScale = 0.1, grid = {2,2})));
  end system;
  model absorbtion
    farmako.fc fc1 annotation(Placement(visible = true, transformation(origin = {-19.6796,12.357}, extent = {{-10,-10},{10,10}}, rotation = 0), iconTransformation(origin = {-5.91533,-0.881007}, extent = {{-13.6957,-13.6957},{13.6957,13.6957}}, rotation = 0)));
    Real mass;
    parameter Real abs;
    Modelica.Blocks.Interfaces.RealInput u annotation(Placement(visible = true, transformation(origin = {-47.5973,58.1236}, extent = {{-10,-10},{10,10}}, rotation = 0), iconTransformation(origin = {-4.11899,80.5492}, extent = {{-10,-10},{10,10}}, rotation = 0)));
  equation
    der(mass) = u + fc1.cq;
    fc1.cq = -mass * abs;
    annotation(Diagram(coordinateSystem(extent = {{-100,-100},{100,100}}, preserveAspectRatio = true, initialScale = 0.1, grid = {2,2})), Icon(coordinateSystem(extent = {{-100,-100},{100,100}}, preserveAspectRatio = true, initialScale = 0.1, grid = {2,2}), graphics = {Polygon(origin = {11.44,-8.01}, fillColor = {255,255,0}, fillPattern = FillPattern.Solid, points = {{-22.4256,91.3043},{-35.2403,28.6041},{-96.1098,36.3844},{-51.2586,-8.00915},{-99.7712,-83.0664},{-22.4256,-24.9428},{8.69565,-94.508},{26.087,-27.2311},{107.551,-55.6064},{52.1739,2.51716},{90.6178,69.7941},{24.714,35.0114},{-22.4256,91.3043}})}));
  end absorbtion;
  model system2
    farmako.absorbtion absorbtion1(abs = 1) annotation(Placement(visible = true, transformation(origin = {-63.6156,-39.8169}, extent = {{-10,-10},{10,10}}, rotation = 0)));
    farmako.kidney kidney1(CL = 2) annotation(Placement(visible = true, transformation(origin = {82.8375,-55.8352}, extent = {{-10,-10},{10,10}}, rotation = 0)));
    farmako.concKomp conckomp1(distVol = 10, startConc = 1) annotation(Placement(visible = true, transformation(origin = {10.984,-50.3432}, extent = {{-10,-10},{10,10}}, rotation = 0)));
    Modelica.Blocks.Sources.Pulse pulse1(amplitude = 10, width = 5, period = 8, nperiod = 12) annotation(Placement(visible = true, transformation(origin = {-75.9725,47.5973}, extent = {{-10,-10},{10,10}}, rotation = 0)));
  equation
    connect(pulse1.y,absorbtion1.u) annotation(Line(points = {{-64.9725,47.5973},{-65.9039,47.5973},{-65.9039,-32.0366},{-65.9039,-32.0366}}));
    connect(conckomp1.fc1,kidney1.fc1) annotation(Line(points = {{10.2517,-48.7414},{83.2952,-48.7414},{83.2952,-55.8352},{83.2952,-55.8352}}));
    connect(absorbtion1.fc1,conckomp1.fc1) annotation(Line(points = {{-64.2071,-39.905},{8.69565,-39.905},{8.69565,-50.3432},{8.69565,-50.3432}}));
    annotation(Icon(coordinateSystem(extent = {{-100,-100},{100,100}}, preserveAspectRatio = true, initialScale = 0.1, grid = {2,2})), Diagram(coordinateSystem(extent = {{-100,-100},{100,100}}, preserveAspectRatio = true, initialScale = 0.1, grid = {2,2})));
  end system2;
  annotation(Icon(coordinateSystem(extent = {{-100,-100},{100,100}}, preserveAspectRatio = true, initialScale = 0.1, grid = {2,2})), Diagram(coordinateSystem(extent = {{-100,-100},{100,100}}, preserveAspectRatio = true, initialScale = 0.1, grid = {2,2})));
end farmako;

